Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.management.modelmbean
Class ModelMBeanAttributeInfo

    java.lang.Object
      javax.management.MBeanFeatureInfo
          javax.management.MBeanAttributeInfo
              javax.management.modelmbean.ModelMBeanAttributeInfo

All Implemented Interfaces:
  Serializable, Cloneable, DescriptorAccess, DescriptorRead

    public class ModelMBeanAttributeInfo

extends MBeanAttributeInfo
implements DescriptorAccess

The ModelMBeanAttributeInfo object describes an attribute of the ModelMBean. It is a subclass of MBeanAttributeInfo with the addition of an associated Descriptor and an implementation of the DescriptorAccess interface.

The fields in the descriptor are defined, but not limited to, the following:

     name           : attribute name
     descriptorType : must be "attribute"
     value          : current value for attribute
     default        : default value for attribute
     displayName    : name of attribute to be used in displays
     getMethod      : name of operation descriptor for get method
     setMethod      : name of operation descriptor for set method
     protocolMap    : object which implements the Descriptor interface: mappings must be appropriate for the attribute
                      and entries can be updated or augmented at runtime.
     persistPolicy  : OnUpdate|OnTimer|NoMoreOftenThan|OnUnregister|Always|Never
     persistPeriod  : seconds - frequency of persist cycle. Used when persistPolicy is"OnTimer" or "NoMoreOftenThan".
     currencyTimeLimit : how long value is valid, <0 never, =0 always, >0 seconds
     lastUpdatedTimeStamp : when value was set
     visibility     : 1-4 where 1: always visible 4: rarely visible
     presentationString : xml formatted string to allow presentation of data

The default descriptor contains the name, descriptorType and displayName fields.

Note: because of inconsistencies in previous versions of this specification, it is recommended not to use negative or zero values for `currencyTimeLimit`. To indicate that a cached value is never valid, omit the `currencyTimeLimit` field. To indicate that it is always valid, use a very large number for this field.

The serialVersionUID of this class is `6181543027787327345L`.

Since:
  1.5
See Also:
  Serialized Form

Field Summary

Fields inherited from class javax.management.MBeanFeatureInfo
`description, name`

Constructor Summary
`ModelMBeanAttributeInfo(ModelMBeanAttributeInfo inInfo)` Constructs a new ModelMBeanAttributeInfo object from this ModelMBeanAttributeInfo Object.
`ModelMBeanAttributeInfo(String name, String description, Method getter, Method setter)` Constructs a ModelMBeanAttributeInfo object with a default descriptor.
`ModelMBeanAttributeInfo(String name, String description, Method getter, Method setter, Descriptor descriptor)` Constructs a ModelMBeanAttributeInfo object.
`ModelMBeanAttributeInfo(String name, String type, String description, boolean isReadable, boolean isWritable, boolean isIs)` Constructs a ModelMBeanAttributeInfo object with a default descriptor.
`ModelMBeanAttributeInfo(String name, String type, String description, boolean isReadable, boolean isWritable, boolean isIs, Descriptor descriptor)` Constructs a ModelMBeanAttributeInfo object with a default descriptor.

Method Summary
`Object` | `clone()` Creates and returns a new ModelMBeanAttributeInfo which is a duplicate of this ModelMBeanAttributeInfo.
`Descriptor` | `getDescriptor()` Gets a copy of the associated Descriptor for the ModelMBeanAttributeInfo.
`void` | `setDescriptor(Descriptor inDescriptor)` Sets associated Descriptor (full replace) for the ModelMBeanAttributeDescriptor.
`String` | `toString()` Returns a human-readable version of the ModelMBeanAttributeInfo instance.

Methods inherited from class javax.management.MBeanAttributeInfo
`equals, getType, hashCode, isIs, isReadable, isWritable`

Methods inherited from class javax.management.MBeanFeatureInfo
`getDescription, getName`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ModelMBeanAttributeInfo

    public ModelMBeanAttributeInfo(String name,
                                   String description,
                                   Method getter,
                                   Method setter)
                            throws IntrospectionException

  Constructs a ModelMBeanAttributeInfo object with a default descriptor. The `Descriptor` of the constructed object will include fields contributed by any annotations on the `Method` objects that contain the `DescriptorKey` meta-annotation.

  Parameters:
    `name` - The name of the attribute.
    `description` - A human readable description of the attribute. Optional.
    `getter` - The method used for reading the attribute value. May be null if the property is write-only.
    `setter` - The method used for writing the attribute value. May be null if the attribute is read-only.
  Throws:
    `IntrospectionException` - There is a consistency problem in the definition of this attribute.

### ModelMBeanAttributeInfo

    public ModelMBeanAttributeInfo(String name,
                                   String description,
                                   Method getter,
                                   Method setter,
                                   Descriptor descriptor)
                            throws IntrospectionException

  Constructs a ModelMBeanAttributeInfo object. The `Descriptor` of the constructed object will include fields contributed by any annotations on the `Method` objects that contain the `DescriptorKey` meta-annotation.

  Parameters:
    `name` - The name of the attribute.
    `description` - A human readable description of the attribute. Optional.
    `getter` - The method used for reading the attribute value. May be null if the property is write-only.
    `setter` - The method used for writing the attribute value. May be null if the attribute is read-only.
    `descriptor` - An instance of Descriptor containing the appropriate metadata for this instance of the Attribute. If it is null, then a default descriptor will be created. If the descriptor does not contain the field "displayName" this field is added in the descriptor with its default value.
  Throws:
    `IntrospectionException` - There is a consistency problem in the definition of this attribute.
    `RuntimeOperationsException` - Wraps an IllegalArgumentException. The descriptor is invalid, or descriptor field "name" is not equal to name parameter, or descriptor field "DescriptorType" is not equal to "attribute".

### ModelMBeanAttributeInfo

    public ModelMBeanAttributeInfo(String name,
                                   String type,
                                   String description,
                                   boolean isReadable,
                                   boolean isWritable,
                                   boolean isIs)

  Constructs a ModelMBeanAttributeInfo object with a default descriptor.

  Parameters:
    `name` - The name of the attribute
    `type` - The type or class name of the attribute
    `description` - A human readable description of the attribute.
    `isReadable` - True if the attribute has a getter method, false otherwise.
    `isWritable` - True if the attribute has a setter method, false otherwise.
    `isIs` - True if the attribute has an "is" getter, false otherwise.

### ModelMBeanAttributeInfo

    public ModelMBeanAttributeInfo(String name,
                                   String type,
                                   String description,
                                   boolean isReadable,
                                   boolean isWritable,
                                   boolean isIs,
                                   Descriptor descriptor)

  Constructs a ModelMBeanAttributeInfo object with a default descriptor.

  Parameters:
    `name` - The name of the attribute
    `type` - The type or class name of the attribute
    `description` - A human readable description of the attribute.
    `isReadable` - True if the attribute has a getter method, false otherwise.
    `isWritable` - True if the attribute has a setter method, false otherwise.
    `isIs` - True if the attribute has an "is" getter, false otherwise.
    `descriptor` - An instance of Descriptor containing the appropriate metadata for this instance of the Attribute. If it is null then a default descriptor will be created. If the descriptor does not contain the field "displayName" this field is added in the descriptor with its default value.
  Throws:
    `RuntimeOperationsException` - Wraps an IllegalArgumentException. The descriptor is invalid, or descriptor field "name" is not equal to name parameter, or descriptor field "DescriptorType" is not equal to "attribute".

### ModelMBeanAttributeInfo

    public ModelMBeanAttributeInfo(ModelMBeanAttributeInfo inInfo)

  Constructs a new ModelMBeanAttributeInfo object from this ModelMBeanAttributeInfo Object. A default descriptor will be created.

  Parameters:
    `inInfo` - the ModelMBeanAttributeInfo to be duplicated

Method Detail

### getDescriptor

    public Descriptor getDescriptor()

  Gets a copy of the associated Descriptor for the ModelMBeanAttributeInfo.

  Specified by:
    `getDescriptor` in interface `DescriptorRead`
  Overrides:
    `getDescriptor` in class `MBeanFeatureInfo`
  Returns:
    Descriptor associated with the ModelMBeanAttributeInfo object.
  See Also:
    `setDescriptor(javax.management.Descriptor)`

### setDescriptor

    public void setDescriptor(Descriptor inDescriptor)

  Sets associated Descriptor (full replace) for the ModelMBeanAttributeDescriptor. If the new Descriptor is null, then the associated Descriptor reverts to a default descriptor. The Descriptor is validated before it is assigned. If the new Descriptor is invalid, then a RuntimeOperationsException wrapping an IllegalArgumentException is thrown.

  Specified by:
    `setDescriptor` in interface `DescriptorAccess`
  Parameters:
    `inDescriptor` - replaces the Descriptor associated with the ModelMBeanAttributeInfo
  Throws:
    `RuntimeOperationsException` - Wraps an IllegalArgumentException for an invalid Descriptor
  See Also:
    `getDescriptor()`

### clone

    public Object clone()

  Creates and returns a new ModelMBeanAttributeInfo which is a duplicate of this ModelMBeanAttributeInfo.

  Overrides:
    `clone` in class `MBeanAttributeInfo`
  Returns:
    a clone of this instance.
  Throws:
    `RuntimeOperationsException` - for illegal value for field Names or field Values. If the descriptor construction fails for any reason, this exception will be thrown.
  See Also:
    `Cloneable`

### toString

    public String toString()

  Returns a human-readable version of the ModelMBeanAttributeInfo instance.

  Overrides:
    `toString` in class `MBeanAttributeInfo`
  Returns:
    a string representation of the object.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2008 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.